#include <linux/types.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/proc_fs.h>
#include <linux/fs.h>
#include <linux/vfs.h>
#include "ngcp_mod.h"

#define S_O(name, member) \
	size_t __ngcp_struct_offset_ ## name ## _ ## member = \
	(size_t) (&((struct name *) 0)->member)

#include "linkage.h"


MODULE_LICENSE("proprietary");


void *ngcp_bouncer;
unsigned long ngcp_c_off_p;
unsigned long ngcp_c_off_c;
unsigned long ngcp_c_off_t;

long ngcp_bounce(long a, long b, long c, long d) {
	asmlinkage long (*f)(long, long, long, long);
	f = ngcp_bouncer;
	return f(a, b, c, d);
}


static int __init init(void) {
	ngcp_c_off_p = (unsigned long) &((typeof(current)) 0)->pid;
	ngcp_c_off_c = (unsigned long) &((typeof(current)) 0)->comm;
	ngcp_c_off_t = (unsigned long) &((typeof(current)) 0)->ptrace;
	return ngcp_mod_init();
}

static void __exit fini(void) {
	ngcp_mod_exit();
}

module_init(init);
module_exit(fini);
